import traceback
from django.http import HttpResponse,JsonResponse

# POST请求 处理时间和参数验证
def handle_post_request_parameters(request, required_params):
    params = {}
    for param in required_params:
        value = request.POST.get(param, '')
        if not value:
            raise ValueError(f"Invalid input parameter: {param} is empty")
        params[param] = value
    return params
# POST请求 不处理参数验证
def handle_post_request_has_empty_parameters(request, required_params):
    params = {}
    for param in required_params:
        value = request.POST.get(param, '')
        params[param] = value
    return params

# GET请求 处理时间和参数验证
def handle_get_request_parameters(request, required_params):
    params = {}
    for param in required_params:
        value = request.GET.get(param, '')
        if not value:
            raise ValueError(f"Invalid input parameter: {param} is empty")
        params[param] = value
    return params


# 统一的错误响应处理 todo===============待拆分----2025-3-31----feng
def handle_error(error_message):
    # 打印错误堆栈信息到日志或控制台
    traceback.print_exc()
    return JsonResponse({"status": "error", "message": error_message}, status=500)