# This is an auto-generated Django model module.
# You'll have to do the following manually to clean this up:
#   * Rearrange models' order
#   * Make sure each model has one field with primary_key=True
#   * Make sure each ForeignKey and OneToOneField has `on_delete` set to the desired behavior
#   * Remove `managed = False` lines if you wish to allow Django to create, modify, and delete the table
# Feel free to rename the models, but don't rename db_table values or field names.
from django.db import models


# This is an auto-generated Django model module.
# You'll have to do the following manually to clean this up:
#   * Rearrange models' order
#   * Make sure each model has one field with primary_key=True
#   * Make sure each ForeignKey and OneToOneField has `on_delete` set to the desired behavior
#   * Remove `managed = False` lines if you wish to allow Django to create, modify, and delete the table
# Feel free to rename the models, but don't rename db_table values or field names.
from django.db import models



class DogTransfer(models.Model):
    d_id = models.CharField(max_length=9, blank=True, null=True, db_comment='狗狗唯一id')
    sender_id = models.CharField(max_length=22, blank=True, null=True, db_comment='赠送者id')
    transfer_code = models.CharField(max_length=255, blank=True, null=True)
    expiry_time = models.DateTimeField(blank=True, null=True, db_comment='二维码过期时间')
    status = models.CharField(max_length=255, blank=True, null=True, db_comment='赠送中：pending，赠送完成：completed，赠送取消：cancelled，赠送失败：failed')
    receiver_id = models.CharField(max_length=22, blank=True, null=True, db_comment='接收者id')
    completed_time = models.DateTimeField(blank=True, null=True, db_comment='接收完成时间')
    cancelled_time = models.DateTimeField(blank=True, null=True, db_comment='取消时间')


    class Meta:
        managed = False
        db_table = 'dog_transfer'



class DogBodyAttributes(models.Model):
    d_id = models.CharField(max_length=9, db_comment='狗id')
    curiosity = models.IntegerField(blank=True, null=True, db_comment='好奇心属性（初始值30-70，范围1-100）')
    iq = models.IntegerField(blank=True, null=True, db_comment='智商属性（初始值30-70，范围1-100）')
    runSpeed = models.IntegerField(blank=True, null=True, db_comment='跑步速度（初始值30-70，范围1-100）')
    jumpHeight = models.IntegerField(blank=True, null=True, db_comment='跳跃速度属性（初始值30-70，范围1-100）')
    liveliness = models.IntegerField(blank=True, null=True, db_comment='活泼度属性（初始值30-70，范围1-100）')
    agility = models.IntegerField(blank=True, null=True, db_comment='敏捷程度（初始值30-70，范围1-100）')
    obesity = models.IntegerField(blank=True, null=True, db_comment='肥胖程度（初始值30-70，范围1-100）')
    frisbeeSkill = models.IntegerField(blank=True, default=10,null=True, db_comment='叼飞盘熟练度（初始值10，范围1-100）')
    ballSkill = models.IntegerField(blank=True, default=10,null=True, db_comment='玩球熟练度（初始值10，范围1-100）')

    class Meta:
        managed = False
        db_table = 'dog_body_attributes'
        unique_together = (('id', 'd_id'),)


class DogPersonalityRelationship(models.Model):
    d_id = models.CharField(max_length=9, db_comment='狗id')
    intimate = models.IntegerField(blank=True, null=True, db_comment='亲密度（初始值20-50，范围1-100）')
    friendly = models.IntegerField(blank=True, null=True, db_comment='对主人友善/恐惧（初始值25-50，范围1-100）')
    obedience = models.IntegerField(blank=True, null=True, db_comment='对主人服从性（初始值25-50，范围1-100）')
    friendlyToHost = models.IntegerField(blank=True, null=True, db_comment='对家人友好程度属性（初始值20-40，范围1-100）')
    friendlyToStranger = models.IntegerField(blank=True, null=True, db_comment='对陌生人友好程度（初始值25-50，范围1-100）')
    friendlyToOtherSSDog = models.IntegerField(blank=True, null=True, db_comment='对同性狗友好程度（初始值20-40，范围1-100）')
    friendlyToOtherDSDog = models.IntegerField(blank=True, null=True, db_comment='对异性别狗友好程度（初始值20-40，范围1-100）')

    class Meta:
        managed = False
        db_table = 'dog_personality_relationship'
        unique_together = (('id', 'd_id'),)


class DogPersonalityRelationshipLog(models.Model):
    d_id = models.IntegerField(blank=True, null=True)
    owner_id = models.CharField(max_length=22, blank=True, null=True, db_comment='用户id')
    log_date = models.DateField(blank=True, null=True, db_comment='当日日期')
    intimate_count = models.IntegerField(blank=True, null=True, db_comment='亲密当日累计次数，属每次+1，每日最多+2')
    friendly_count = models.IntegerField(blank=True, null=True, db_comment='友善当日累计次数，属每次+1，每日最多+2')
    obedience_count = models.IntegerField(blank=True, null=True, db_comment='服从当日累计次数， 属性每次+1，每日最多+2')

    class Meta:
        managed = False
        db_table = 'dog_personality_relationship_log'



class DogStatus(models.Model):
    id = models.IntegerField(primary_key=True)  # The composite primary key (id, d_id) found, that is not supported. The first column is selected.
    d_id = models.CharField(max_length=9, db_comment='狗id')
    satiety = models.IntegerField(blank=True, default=50,null=True, db_comment='饥饿属性(初始值50，范围1-100)')
    happiness = models.IntegerField(blank=True,default=50, null=True, db_comment='快乐属性(初始值50，范围1-100)）')
    stamina = models.IntegerField(blank=True, default=50,null=True, db_comment='体力属性(初始值50，范围1-100)')
    thirsty = models.IntegerField(blank=True, default=50,null=True, db_comment='口渴属性（初始值50，范围1-100）')
    healthy = models.IntegerField(blank=True, default=50,null=True, db_comment='健康属性（初始值50，范围1-100）')
    clean = models.IntegerField(blank=True, default=50,null=True, db_comment='干净属性（初始值50，范围1-100）')
    time_lasttime = models.DateTimeField(blank=True, null=True, db_comment='上次请求更新时间')

    class Meta:
        managed = False
        db_table = 'dog_status'
        unique_together = (('id', 'd_id'),)

class DogTrainingNew(models.Model):
    d_id = models.CharField(max_length=9, db_comment='狗id')
    voicecommand = models.IntegerField(db_column='voiceCommand', default=0,blank=True, null=True, db_comment='训练能力（初始值1，范围1-100）')  # Field name made lowercase.
    voicecall = models.IntegerField(db_column='voiceCall', default=0,blank=True, null=True, db_comment='识自己的名字能力（初始值1，范围1-100）')  # Field name made lowercase.
    commandsit = models.IntegerField(db_column='commandSit', default=0,blank=True, null=True, db_comment='是否拥有识别坐的能力：拥有1，未获得：0')  # Field name made lowercase.
    commandstand = models.IntegerField(db_column='commandStand', default=0,blank=True, null=True, db_comment='是否拥有识别站起的能力：拥有1，未获得：0')  # Field name made lowercase.
    commandbark = models.IntegerField(db_column='commandBark', default=0,blank=True, null=True, db_comment='是否拥有识别吼人的能力：拥有1，未获得：0')  # Field name made lowercase.
    commandliedown = models.IntegerField(db_column='commandLieDown', default=0,blank=True, null=True, db_comment='是否拥有识别吼人的能力：拥有1，未获得：0')  # Field name made lowercase.
    commandshake = models.IntegerField(db_column='commandShake', default=0,blank=True, null=True, db_comment='是否拥有识别躺下的能力：拥有1，未获得：0')  # Field name made lowercase.
    commandtouch = models.IntegerField(db_column='commandTouch', default=0,blank=True, null=True, db_comment='是否拥有识别拥抱的能力：拥有1，未获得：0')  # Field name made lowercase.
    commanddeath = models.IntegerField(db_column='commandDeath', default=0,blank=True, null=True, db_comment='是否拥有识别装死的能力：拥有1，未获得：0')  # Field name made lowercase.
    commandturnl = models.IntegerField(db_column='commandTurnL', default=0,blank=True, null=True, db_comment='是否拥有识别向左的能力：拥有1，未获得：0')  # Field name made lowercase.
    commandturnr = models.IntegerField(db_column='commanTurnR',default=0, blank=True, null=True, db_comment='是否拥有识别向右的能力：拥有1，未获得：0')  # Field name made lowercase.
    voicecallenable = models.IntegerField(db_column='voiceCallEnable',default=0,  blank=True, null=True, db_comment='默认0，区别是否首次')  # Field name made lowercase.
    voicecommandenable = models.IntegerField(db_column='voiceCommandEnable', default=0,blank=True, null=True, db_comment='默认0，区别是否首次')  # Field name made lowercase.

    class Meta:
        managed = False
        db_table = 'dog_training_new'
        unique_together = (('id', 'd_id'),)

class DogTrainingLog(models.Model):
    d_id = models.CharField(max_length=9, blank=True, null=True, db_comment='狗狗唯一id')
    owner_id = models.CharField(max_length=22, blank=True, null=True, db_comment='用户id')
    command_type = models.CharField(max_length=255, blank=True, null=True, db_comment='训练口令 类型')
    training_date = models.DateField(blank=True, null=True)
    training_count = models.IntegerField(blank=True, null=True, db_comment='当日训练次数')

    class Meta:
        managed = False
        db_table = 'dog_training_log'



class DogTraining(models.Model):
    d_id = models.CharField(max_length=9, db_comment='狗id')
    frisbeeSkill = models.IntegerField(blank=True,  default=10,null=True, db_comment='叼飞盘熟练度（初始值1，范围1-100）')
    ballSkill = models.IntegerField(blank=True,default=10, null=True, db_comment='玩球熟练度（初始值1，范围1-100）')
    commandName = models.IntegerField(blank=True, default=10,null=True, db_comment='识别自己的名字（初始值1，范围1-100）')
    commandSit = models.IntegerField(blank=True, default=10,null=True, db_comment='识别坐口令（初始值1，范围1-100）')
    commandLieDown = models.IntegerField(blank=True, default=10,null=True, db_comment='识别躺下口令（初始值1，范围1-100）')
    commandRotate = models.IntegerField(blank=True, default=10,null=True, db_comment='识别转圈口令（初始值1，范围1-100）')
    numbers_of_calls = models.IntegerField(blank=True, default=10,null=True, db_comment='呼唤次数，每日最多999')
    time_lasttime = models.DateTimeField(blank=True, null=True, db_comment='上次请求更新时间')

    class Meta:
        managed = False
        db_table = 'dog_training'
        unique_together = (('id', 'd_id'),)


class Doginfo(models.Model):
    d_id = models.CharField(max_length=9, db_comment='狗狗唯一id')
    owner_id = models.CharField(max_length=22, db_comment='用户id')
    dog_name = models.CharField(max_length=10, blank=True, null=True, db_comment='狗的名字')
    sex = models.IntegerField(db_comment='狗的性别（母：0，公：1）')
    breed = models.CharField(max_length=10,blank=True, null=True, db_comment='狗的品种（1：哈士奇，2：阿拉斯加，3：柯基，4：沙皮，5：金毛））')
    birthday = models.DateTimeField(blank=True, null=True, db_comment='狗的生日')
    skin = models.CharField(max_length=22, db_comment='狗的皮肤')
    adoption = models.CharField(max_length=22, default='home', db_comment='领养状态：home 家养；fostered 寄养')
    transfer_status=models.IntegerField(blank=True,default=0, null=True, db_comment='转移状态：1（转移中），0（可转移）')

    class Meta:
        managed = False
        db_table = 'doginfo'
        unique_together = (('id', 'owner_id'),)



class GroupIdList(models.Model):
    id = models.IntegerField(primary_key=True)
    group_id = models.CharField(max_length=255, blank=True, null=True, db_comment='以年月分组group_id，每月用户在同一组，初始化月份查表，无则创建groupid')

    class Meta:
        managed = False
        db_table = 'group_id_list'


class LoginTokens(models.Model):
    login_token = models.CharField(max_length=255)
    created_at = models.DateTimeField(blank=True, null=True, db_comment='logintoken创建时间')
    uid = models.CharField(max_length=22)
    expires_at = models.DateTimeField(blank=True, null=True, db_comment='logintoken过期时间')

    class Meta:
        managed = False
        db_table = 'login_tokens'


class AccessTokens(models.Model):
    uid = models.CharField(max_length=22, db_comment='用户id')
    access_token = models.CharField(max_length=255)
    created_at = models.DateTimeField(blank=True, null=True, db_comment='创建时间')
    expires_at = models.DateTimeField(db_comment='过期时间')

    class Meta:
        managed = False
        db_table = 'access_tokens'



class InventoryInfo(models.Model):
    item_id = models.CharField(max_length=20,blank=True, null=True)
    item_name = models.CharField(max_length=100, blank=True, null=True, db_comment='道具名称')
    item_type = models.CharField(max_length=20, blank=True, null=True, db_comment='道具类型（食 物，玩具，其他）')
    price = models.IntegerField(blank=True, null=True, db_comment='价格（金币）')
    is_active = models.IntegerField(default=1,blank=True, null=True, db_comment='是否可购买（1可以，0不可 购买）')
    created_at = models.DateTimeField(auto_now_add=True,blank=True, null=True, db_comment='创建时间')
    updated_at = models.DateTimeField(auto_now=True,blank=True, null=True, db_comment='更新时间')
    description = models.TextField(blank=True, null=True, db_comment='道具描述')

    class Meta:
        managed = False
        db_table = 'inventory_info'

class UserInventory(models.Model):
    item_id = models.CharField(max_length=22, blank=True, null=True, db_comment='道具id')
    owner_id = models.CharField(max_length=22, blank=True, null=True, db_comment='用户id')
    quantity = models.IntegerField(blank=True,   default=0, null=True, db_comment='道具数量')

    class Meta:
        managed = False
        db_table = 'user_inventory'


class User(models.Model):
    uid = models.CharField(max_length=22, db_comment='用户id')
    mobile = models.CharField(max_length=55, blank=True, null=True, db_comment='用户手机号')
    password = models.CharField(max_length=255, blank=True, null=True, db_comment='用户密码')
    uuid = models.CharField(max_length=22, blank=True, null=True, db_comment='手机串号')
    login_token = models.CharField(max_length=255, blank=True, null=True, db_comment='登录令牌7天有效')
    access_token = models.CharField(max_length=255, blank=True, null=True, db_comment='请求令牌1天有效')
    coin = models.IntegerField(blank=True,   default=1000,null=True, db_comment='金币数量(初始值1000，范围10000000)')
    voice_feature_id = models.CharField(max_length=255, db_collation='utf8_general_ci', blank=True, null=True, db_comment='用户声纹特征id')
    voice_sit_command = models.TextField(blank=True, null=True, db_comment='用户“坐下”指令音频')
    voice_stand_command = models.TextField(blank=True, null=True, db_comment='用户“站起来”指令音频')
    voice_feature_info_param = models.CharField(max_length=255, db_collation='utf8_general_ci', blank=True, null=True, db_comment='用户声纹信息参数')
    voice_update_feature_info_param = models.CharField(max_length=255, db_collation='utf8_general_ci', blank=True, null=True, db_comment='用户更新声纹信息参数')
    registration_time = models.DateTimeField(blank=True, null=True, db_comment='用户注册时间')
    is_sit = models.IntegerField(blank=True,   default=0,null=True, db_comment='是否坐下口令（是：1，否0）')
    is_stand = models.IntegerField(blank=True,  default=1, null=True, db_comment='是否站起口令（是：1，否0）')
    isRegUser = models.IntegerField(blank=True,   default=0,null=True, db_comment='是否为临时用户')
    email = models.CharField(max_length=22, blank=True, null=True, db_comment='英文用户登录使用')
    user_name = models.CharField(max_length=255, blank=True, null=True, db_comment='用户名')
    level = models.CharField(max_length=10, blank=True,  default='basic',null=True, db_comment='用户等级')
    last_login_date = models.DateTimeField(blank=True, null=True, db_comment='用户最近一次登录时间')

    class Meta:
        managed = False
        db_table = 'user'

class AidogFeedbacks(models.Model):
    feedback_id = models.IntegerField(primary_key=True, db_comment='反馈id自增')
    uid = models.CharField(blank=True, null=True, db_comment='用户id')
    create_time = models.DateTimeField(blank=True, null=True, db_comment='反馈时间')
    feedback_type = models.CharField(max_length=10, blank=True, null=True, db_comment='bug/comment')
    feedback_content = models.TextField(blank=True, null=True, db_comment='反馈内容')
    contact_info = models.CharField(max_length=100, blank=True, null=True, db_comment='联系方式')
    feedback_status = models.IntegerField(blank=True, null=True, db_comment='反馈记录状态（0：待理，1：已处理）')
    staff_id = models.CharField(max_length=22, blank=True, null=True, db_comment='处理人id')
    handle_time = models.DateTimeField(blank=True, null=True, db_comment='处理时间')
    handle_content = models.TextField(blank=True, null=True, db_comment='处理结果')

    class Meta:
        managed = False
        db_table = 'aidog_feedbacks'


class VoiceFeatureInfo(models.Model):
    uid = models.CharField(max_length=22, db_comment='用户id')
    d_id = models.CharField(max_length=9, db_comment='狗狗唯一id')
    voice_group_id = models.CharField(blank=True, null=True, db_comment='声纹库id')
    voice_feature_id = models.CharField(max_length=250, blank=True, null=True, db_comment='每条声纹数据的声纹id')
    voice_feature_info_param = models.CharField(max_length=255, blank=True, null=True, db_comment='用户声纹信息参数')
    voice_update_feature_info_param = models.CharField(max_length=255, blank=True, null=True, db_comment='用户更新声纹信息参数')
    record_time = models.DateTimeField(blank=True, null=True, db_comment='用户录音时间')
    command_type = models.CharField(max_length=250,blank=True, null=True, db_comment='口令类型（voiceCall，voiceCommandSit，voiceCommandStand）')
    voice_path= models.CharField(max_length=250, blank=True, null=True, db_comment='本地音频存储路径')
    mfcc = models.TextField(blank=True, null=True, db_comment='本地音频算法取出的每个音频唯一mfcc特征值用于比对')

    class Meta:
        managed = False
        db_table = 'voice_feature_info'


class VoiceCompareScores(models.Model):
    voice_feature_id = models.CharField(max_length=250, db_comment='声纹id')
    uid = models.CharField(max_length=22, blank=True, null=True, db_comment='用户id')
    keda_score = models.DecimalField(db_column='KEDA_score', max_digits=5, decimal_places=2, blank=True, null=True, db_comment='科大声纹比对得分')  # Field name made lowercase.
    mfcc_score = models.DecimalField(db_column='MFCC_score', max_digits=5, decimal_places=2, blank=True, null=True, db_comment='本地声纹算法得分')  # Field name made lowercase.
    kedacompare_spend_time = models.FloatField(db_column='KEDAcompare_spend_time', blank=True, null=True, db_comment='科 大比对消耗时间')  # Field name made lowercase.
    mfcccompare_spend_time = models.FloatField(db_column='MFCCcompare_spend_time', blank=True, null=True, db_comment='本 地算法比对消耗时间')  # Field name made lowercase.
    createtime = models.DateTimeField(blank=True, null=True, db_comment='创建时间')

    class Meta:
        managed = False
        db_table = 'voice_compare_scores'


class WalkDogsScore(models.Model):
    uid = models.CharField(max_length=22, db_comment='用户id')
    d_id = models.CharField(max_length=9, blank=True, null=True, db_comment='狗id')
    score = models.IntegerField(blank=True, null=True, db_comment='遛狗得分')
    maxcombo = models.IntegerField(db_column='maxCombo', blank=True, null=True, db_comment='最大续击中')  # Field name made lowercase.
    perfect = models.IntegerField(blank=True, null=True, db_comment='完美击中数量')
    good = models.IntegerField(blank=True, null=True, db_comment='不错击中数量')
    poor = models.IntegerField(blank=True, null=True, db_comment='较差击中数量')
    miss = models.IntegerField(blank=True, null=True, db_comment='错过击中数量')
    walk_time = models.DateTimeField(blank=True, null=True, db_comment='遛狗时间')
    walk_count = models.IntegerField(blank=True, null=True, db_comment='今日遛狗次数')

    class Meta:
        managed = False
        db_table = 'walk_dogs_score'


class FrisbeeDogsScore(models.Model):
    uid = models.CharField(max_length=22, blank=True, null=True, db_comment='用户id')
    d_id = models.CharField(max_length=9, blank=True, null=True, db_comment='狗id')
    item_id = models.CharField(max_length=22, blank=True, null=True, db_comment='不同类型飞盘id')
    catch = models.IntegerField(blank=True, null=True, db_comment='true接到飞盘，false没有接到')
    distance = models.FloatField( blank=True, null=True, db_comment='丢飞盘距离')
    frisbee_time = models.DateTimeField(blank=True, null=True, db_comment='丢飞盘日期')
    frisbee_count = models.IntegerField(blank=True, null=True, db_comment='统计次数')

    class Meta:
        managed = False
        db_table = 'frisbee_dogs_score'



